// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2022 Torsten Schache, Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


using Gtk;
using Hiperscan.GuiExtensions.Dialog;
using Hiperscan.GtkExtensions.Widgets;
using Hiperscan.Unix;

namespace Hiperscan.GtkExtensions.StandardDialogs
{
    public class ErrorDialogWithHelp : ErrorDialog
    {
        protected ErrorDialogWithHelp(Gtk.Window parent, DialogArgsTempleate arg) : base(parent, arg)
        {
            this.Message += ErrorDialog.ServiceForRepeatedError;
        }

        protected override void ExtendDialog(MessageDialog mdlg)
        {
            Gtk.Alignment alignment = new Alignment(1f, 0.5f, 1f, 1f);
            Gtk.Label label = new Gtk.Label(Catalog.GetString("Show further information"));
            alignment.Add(label);

            LinkLabel link_label = new LinkLabel(label);
            label.SetAlignment(1f, 0.5f);

            mdlg.VBox.PackStart(alignment);
            label.Show();

            link_label.Clicked += (sender, e) =>
            { 
                mdlg.Destroy();
                this.Arg.EventHandler(this.Arg.EventHandlerObject, this.Arg.EventHandlerEventArgs);
            };
        }
       
        public static new void Run(Gtk.Window parent, DialogArgsTempleate arg)
        {
            ErrorDialogWithHelp tmp = new ErrorDialogWithHelp(parent, arg);

            tmp.ShowDialog(Gtk.DialogFlags.Modal,
                            Gtk.MessageType.Error,
                            Gtk.ButtonsType.Ok);
        }
    }
}
